/*
Copyright (c) 2020 Red Hat, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// IMPORTANT: This file has been generated automatically, refrain from modifying it manually as all
// your changes will be lost when the file is generated again.

package v1 // github.com/openshift-online/ocm-sdk-go/clustersmgmt/v1

// AWSMachinePoolKind is the name of the type used to represent objects
// of type 'AWS_machine_pool'.
const AWSMachinePoolKind = "AWSMachinePool"

// AWSMachinePoolLinkKind is the name of the type used to represent links
// to objects of type 'AWS_machine_pool'.
const AWSMachinePoolLinkKind = "AWSMachinePoolLink"

// AWSMachinePoolNilKind is the name of the type used to nil references
// to objects of type 'AWS_machine_pool'.
const AWSMachinePoolNilKind = "AWSMachinePoolNil"

// AWSMachinePool represents the values of the 'AWS_machine_pool' type.
//
// Representation of aws machine pool specific parameters.
type AWSMachinePool struct {
	bitmap_           uint32
	id                string
	href              string
	spotMarketOptions *AWSSpotMarketOptions
}

// Kind returns the name of the type of the object.
func (o *AWSMachinePool) Kind() string {
	if o == nil {
		return AWSMachinePoolNilKind
	}
	if o.bitmap_&1 != 0 {
		return AWSMachinePoolLinkKind
	}
	return AWSMachinePoolKind
}

// Link returns true iif this is a link.
func (o *AWSMachinePool) Link() bool {
	return o != nil && o.bitmap_&1 != 0
}

// ID returns the identifier of the object.
func (o *AWSMachinePool) ID() string {
	if o != nil && o.bitmap_&2 != 0 {
		return o.id
	}
	return ""
}

// GetID returns the identifier of the object and a flag indicating if the
// identifier has a value.
func (o *AWSMachinePool) GetID() (value string, ok bool) {
	ok = o != nil && o.bitmap_&2 != 0
	if ok {
		value = o.id
	}
	return
}

// HREF returns the link to the object.
func (o *AWSMachinePool) HREF() string {
	if o != nil && o.bitmap_&4 != 0 {
		return o.href
	}
	return ""
}

// GetHREF returns the link of the object and a flag indicating if the
// link has a value.
func (o *AWSMachinePool) GetHREF() (value string, ok bool) {
	ok = o != nil && o.bitmap_&4 != 0
	if ok {
		value = o.href
	}
	return
}

// Empty returns true if the object is empty, i.e. no attribute has a value.
func (o *AWSMachinePool) Empty() bool {
	return o == nil || o.bitmap_&^1 == 0
}

// SpotMarketOptions returns the value of the 'spot_market_options' attribute, or
// the zero value of the type if the attribute doesn't have a value.
//
// Use spot instances on this machine pool to reduce cost.
func (o *AWSMachinePool) SpotMarketOptions() *AWSSpotMarketOptions {
	if o != nil && o.bitmap_&8 != 0 {
		return o.spotMarketOptions
	}
	return nil
}

// GetSpotMarketOptions returns the value of the 'spot_market_options' attribute and
// a flag indicating if the attribute has a value.
//
// Use spot instances on this machine pool to reduce cost.
func (o *AWSMachinePool) GetSpotMarketOptions() (value *AWSSpotMarketOptions, ok bool) {
	ok = o != nil && o.bitmap_&8 != 0
	if ok {
		value = o.spotMarketOptions
	}
	return
}

// AWSMachinePoolListKind is the name of the type used to represent list of objects of
// type 'AWS_machine_pool'.
const AWSMachinePoolListKind = "AWSMachinePoolList"

// AWSMachinePoolListLinkKind is the name of the type used to represent links to list
// of objects of type 'AWS_machine_pool'.
const AWSMachinePoolListLinkKind = "AWSMachinePoolListLink"

// AWSMachinePoolNilKind is the name of the type used to nil lists of objects of
// type 'AWS_machine_pool'.
const AWSMachinePoolListNilKind = "AWSMachinePoolListNil"

// AWSMachinePoolList is a list of values of the 'AWS_machine_pool' type.
type AWSMachinePoolList struct {
	href  string
	link  bool
	items []*AWSMachinePool
}

// Kind returns the name of the type of the object.
func (l *AWSMachinePoolList) Kind() string {
	if l == nil {
		return AWSMachinePoolListNilKind
	}
	if l.link {
		return AWSMachinePoolListLinkKind
	}
	return AWSMachinePoolListKind
}

// Link returns true iif this is a link.
func (l *AWSMachinePoolList) Link() bool {
	return l != nil && l.link
}

// HREF returns the link to the list.
func (l *AWSMachinePoolList) HREF() string {
	if l != nil {
		return l.href
	}
	return ""
}

// GetHREF returns the link of the list and a flag indicating if the
// link has a value.
func (l *AWSMachinePoolList) GetHREF() (value string, ok bool) {
	ok = l != nil && l.href != ""
	if ok {
		value = l.href
	}
	return
}

// Len returns the length of the list.
func (l *AWSMachinePoolList) Len() int {
	if l == nil {
		return 0
	}
	return len(l.items)
}

// Empty returns true if the list is empty.
func (l *AWSMachinePoolList) Empty() bool {
	return l == nil || len(l.items) == 0
}

// Get returns the item of the list with the given index. If there is no item with
// that index it returns nil.
func (l *AWSMachinePoolList) Get(i int) *AWSMachinePool {
	if l == nil || i < 0 || i >= len(l.items) {
		return nil
	}
	return l.items[i]
}

// Slice returns an slice containing the items of the list. The returned slice is a
// copy of the one used internally, so it can be modified without affecting the
// internal representation.
//
// If you don't need to modify the returned slice consider using the Each or Range
// functions, as they don't need to allocate a new slice.
func (l *AWSMachinePoolList) Slice() []*AWSMachinePool {
	var slice []*AWSMachinePool
	if l == nil {
		slice = make([]*AWSMachinePool, 0)
	} else {
		slice = make([]*AWSMachinePool, len(l.items))
		copy(slice, l.items)
	}
	return slice
}

// Each runs the given function for each item of the list, in order. If the function
// returns false the iteration stops, otherwise it continues till all the elements
// of the list have been processed.
func (l *AWSMachinePoolList) Each(f func(item *AWSMachinePool) bool) {
	if l == nil {
		return
	}
	for _, item := range l.items {
		if !f(item) {
			break
		}
	}
}

// Range runs the given function for each index and item of the list, in order. If
// the function returns false the iteration stops, otherwise it continues till all
// the elements of the list have been processed.
func (l *AWSMachinePoolList) Range(f func(index int, item *AWSMachinePool) bool) {
	if l == nil {
		return
	}
	for index, item := range l.items {
		if !f(index, item) {
			break
		}
	}
}
