/*
Copyright (c) 2020 Red Hat, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// IMPORTANT: This file has been generated automatically, refrain from modifying it manually as all
// your changes will be lost when the file is generated again.

package v1 // github.com/openshift-online/ocm-sdk-go/servicemgmt/v1

// StatefulObjectBuilder contains the data and logic needed to build 'stateful_object' objects.
//
//
type StatefulObjectBuilder struct {
	bitmap_ uint32
	id      string
	href    string
	kind    string
	state   string
}

// NewStatefulObject creates a new builder of 'stateful_object' objects.
func NewStatefulObject() *StatefulObjectBuilder {
	return &StatefulObjectBuilder{}
}

// Empty returns true if the builder is empty, i.e. no attribute has a value.
func (b *StatefulObjectBuilder) Empty() bool {
	return b == nil || b.bitmap_ == 0
}

// ID sets the value of the 'ID' attribute to the given value.
//
//
func (b *StatefulObjectBuilder) ID(value string) *StatefulObjectBuilder {
	b.id = value
	b.bitmap_ |= 1
	return b
}

// Href sets the value of the 'href' attribute to the given value.
//
//
func (b *StatefulObjectBuilder) Href(value string) *StatefulObjectBuilder {
	b.href = value
	b.bitmap_ |= 2
	return b
}

// Kind sets the value of the 'kind' attribute to the given value.
//
//
func (b *StatefulObjectBuilder) Kind(value string) *StatefulObjectBuilder {
	b.kind = value
	b.bitmap_ |= 4
	return b
}

// State sets the value of the 'state' attribute to the given value.
//
//
func (b *StatefulObjectBuilder) State(value string) *StatefulObjectBuilder {
	b.state = value
	b.bitmap_ |= 8
	return b
}

// Copy copies the attributes of the given object into this builder, discarding any previous values.
func (b *StatefulObjectBuilder) Copy(object *StatefulObject) *StatefulObjectBuilder {
	if object == nil {
		return b
	}
	b.bitmap_ = object.bitmap_
	b.id = object.id
	b.href = object.href
	b.kind = object.kind
	b.state = object.state
	return b
}

// Build creates a 'stateful_object' object using the configuration stored in the builder.
func (b *StatefulObjectBuilder) Build() (object *StatefulObject, err error) {
	object = new(StatefulObject)
	object.bitmap_ = b.bitmap_
	object.id = b.id
	object.href = b.href
	object.kind = b.kind
	object.state = b.state
	return
}
